Loading...
Searching...
No Matches
type.hh File Reference

A unique label for each type of element that can occur in a grid. More...

`#include <cassert>`
`#include <cstdint>`
`#include <string>`
`#include <type_traits>`
`#include <dune/common/exceptions.hh>`
`#include <dune/common/typetraits.hh>`
`#include <dune/common/unused.hh>`

Go to the source code of this file.

## Classes

class | Dune::GeometryType
| Unique label for each type of entities that can occur in DUNE grids. More...

## Namespaces

namespace | Dune
namespace | Dune::GeometryTypes
| Predefined GeometryTypes for common geometries.

## Functions

std::ostream & | Dune::operator<< (std::ostream &s, const GeometryType &a)
| Prints the type to an output stream.
constexpr GeometryType | Dune::GeometryTypes::simplex (unsigned int dim)
| Returns a GeometryType representing a simplex of dimension dim.
constexpr GeometryType | Dune::GeometryTypes::cube (unsigned int dim)
| Returns a GeometryType representing a hypercube of dimension dim.
constexpr GeometryType | Dune::GeometryTypes::none (unsigned int dim)
| Returns a GeometryType representing a singular of dimension dim.
constexpr GeometryType | Dune::GeometryTypes::conicalExtension (const GeometryType &gt)
| Return GeometryType of a conical construction with gt as base.
constexpr GeometryType | Dune::GeometryTypes::prismaticExtension (const GeometryType &gt)
| Return GeometryType of a prismatic construction with gt as base.

## Variables

constexpr GeometryType | Dune::GeometryTypes::vertex = GeometryType(0,0,false)
| GeometryType representing a vertex.
constexpr GeometryType | Dune::GeometryTypes::line = GeometryType(0,1,false)
| GeometryType representing a line.
constexpr GeometryType | Dune::GeometryTypes::triangle = simplex(2)
| GeometryType representing a triangle.
constexpr GeometryType | Dune::GeometryTypes::quadrilateral = cube(2)
| GeometryType representing a quadrilateral (a square).
constexpr GeometryType | Dune::GeometryTypes::tetrahedron = simplex(3)
| GeometryType representing a tetrahedron.
constexpr GeometryType | Dune::GeometryTypes::pyramid = GeometryType(0b0011,3,false)
| GeometryType representing a 3D pyramid.
constexpr GeometryType | Dune::GeometryTypes::prism = GeometryType(0b0101,3,false)
| GeometryType representing a 3D prism.
constexpr GeometryType | Dune::GeometryTypes::hexahedron = cube(3)
| GeometryType representing a hexahedron.

## Detailed Description

A unique label for each type of element that can occur in a grid.